package jp.ac.kagawa_u.eng.wappen.simplejava.nature;

import org.eclipse.core.resources.ICommand;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IProjectNature;
import org.eclipse.core.runtime.CoreException;

public class ProjectNature implements IProjectNature {
  
  public static final String NATURE_ID = "jp.ac.kagawa_u.eng.wappen.simplejava.nature";
  private IProject project;
  public void configure() throws CoreException {
    // EclipsevOCJ@OU p.258
    IProjectDescription desc = project.getDescription();
    ICommand[] commands = desc.getBuildSpec();
    
    for(ICommand c : commands) {
      if (c.getBuilderName().equals(ProjectBuilder.BUILDER_ID)) {
        return;
      }
    }
    
    ICommand[] newCommands = new ICommand[commands.length + 1];
    System.arraycopy(commands, 0, newCommands, 0, commands.length);
    ICommand command = desc.newCommand();
    command.setBuilderName(ProjectBuilder.BUILDER_ID);
    newCommands[commands.length] = command;
    desc.setBuildSpec(newCommands);
    
    project.setDescription(desc, null);
  }

  public void deconfigure() throws CoreException {
  }

  public IProject getProject() {
    return project;
  }

  public void setProject(IProject project) {
    this.project = project;
  }

}
